-- D_FF
-- Implementacao de um FF Tipo D com clear assíncrono e clock enable
--
entity d_ff is
	port
	(
		clk, clr, en	: in bit;		-- Sinais de Controle
		d					: in bit;		-- Entrada de dados
		q					: out bit		-- Saida de dados
	);
end d_ff;

architecture rtl of d_ff is
begin
	process (clk, clr)
	begin
		if (clr = '1') then
			q <= '0';
		elsif (en = '1') then
			if (clk'event and clk = '1') then
				q <= d;		-- Equacao Caracteristica do FF Tipo-D: Q = D
			end if;
		end if;
	end process;
end rtl;
